<template>
  <q-select
    outlined
    bg-color="white"
    :model-value="modelValue"
    use-input
    hide-selected
    fill-input
    input-debounce="0"
    :options="currencyOptions"
    @input-value="setCurrency"
    @filter="filterCurrencies"
    label="Currency"
    hint="The local currency that you are using (e.g. AUD, USD, etc)."
    :rules="[val => !!val || 'Field is required']"
  />
</template>

<script>
import { defineComponent } from 'vue'

export default defineComponent({
  name: 'CurrencySelect',

  props: {
    modelValue: String
  },

  data () {
    return {
      currencies: ['', 'AED', 'AFN', 'ALL', 'AMD', 'ANG', 'AOA', 'ARS', 'AUD', 'AWG', 'AZN', 'BAM', 'BBD', 'BDT', 'BGN', 'BHD', 'BIF', 'BMD', 'BND', 'BOB', 'BRL', 'BSD', 'BTN', 'BWP', 'BYN', 'BYR', 'BZD', 'CAD', 'CDF', 'CHF', 'CLF', 'CLP', 'CNY', 'COP', 'CRC', 'CUC', 'CVE', 'CZK', 'DJF', 'DKK', 'DOP', 'DZD', 'EGP', 'ERN', 'ETB', 'EUR', 'FJD', 'FKP', 'GBP', 'GEL', 'GHS', 'GIP', 'GMD', 'GNF', 'GTQ', 'GYD', 'HKD', 'HNL', 'HRK', 'HTG', 'HUF', 'IDR', 'ILS', 'INR', 'IQD', 'ISK', 'JMD', 'JOD', 'JPY', 'KES', 'KGS', 'KHR', 'KMF', 'KRW', 'KWD', 'KYD', 'KZT', 'LAK', 'LBP', 'LKR', 'LRD', 'LSL', 'LYD', 'MAD', 'MDL', 'MGA', 'MKD', 'MMK', 'MNT', 'MOP', 'MRO', 'MUR', 'MVR', 'MWK', 'MXN', 'MYR', 'MZN', 'NAD', 'NGN', 'NIO', 'NOK', 'NPR', 'NZD', 'OMR', 'PAB', 'PEN', 'PGK', 'PHP', 'PKR', 'PLN', 'PYG', 'QAR', 'RON', 'RSD', 'RUB', 'RWF', 'SAR', 'SBD', 'SCR', 'SEK', 'SHP', 'SLL', 'SOS', 'SRD', 'SSP', 'STD', 'SVC', 'SZL', 'THB', 'TJS', 'TMT', 'TND', 'TOP', 'TRY', 'TTD', 'TWD', 'TZS', 'UAH', 'UGX', 'UYU', 'UZS', 'VES', 'VND', 'VUV', 'WST', 'XAF', 'XAG', 'XAU', 'XCD', 'XDR', 'XOF', 'XPD', 'XPF', 'XPT', 'YER', 'ZAR', 'ZMW', 'JEP', 'GGP', 'IMP', 'GBX', 'CNH', 'TMM', 'ZWL', 'SGD', 'USD', 'BTC', 'BCH', 'BSV', 'ETH', 'ETH2', 'ETC', 'LTC', 'ZRX', 'USDC', 'BAT', 'MANA', 'KNC', 'LINK', 'DNT', 'MKR', 'CVC', 'OMG', 'DAI', 'ZEC', 'XRP', 'REP', 'XLM', 'EOS', 'XTZ', 'ALGO', 'DASH', 'ATOM', 'OXT', 'COMP', 'ENJ', 'REPV2', 'BAND', 'NMR', 'CGLD', 'UMA', 'LRC', 'YFI', 'UNI', 'BAL', 'REN', 'WBTC', 'NU', 'YFII', 'FIL', 'AAVE', 'BNT', 'GRT', 'SNX', 'STORJ', 'SUSHI', 'MATIC', 'SKL', 'ADA', 'ANKR', 'CRV', 'ICP', 'NKN', 'OGN', '1INCH', 'USDT', 'FORTH', 'CTSI', 'TRB', 'POLY', 'MIR', 'RLC', 'DOT', 'SOL', 'DOGE', 'MLN', 'GTC', 'AMP', 'SHIB', 'CHZ', 'KEEP', 'LPT', 'QNT', 'BOND', 'RLY', 'CLV', 'FARM', 'MASK', 'FET', 'PAX', 'ACH', 'ASM', 'PLA', 'RAI', 'TRIBE', 'ORN', 'IOTX', 'UST', 'QUICK', 'AXS', 'REQ', 'WLUNA', 'TRU', 'RAD', 'COTI', 'DDX', 'SUKU', 'RGT', 'XYO', 'ZEN', 'AUCTION', 'JASMY', 'WCFG', 'BTRST', 'AGLD', 'AVAX', 'FX', 'TRAC', 'LCX', 'ARPA', 'BADGER', 'KRL', 'PERP', 'RARI', 'CRO', 'GYEN'],
      currencyOptions: this.currencies
    }
  },

  methods: {
    filterCurrencies (val, update, abort) {
      update(() => {
        const needle = val.toLocaleLowerCase()
        this.currencyOptions = this.currencies.filter(v => v.toLocaleLowerCase().indexOf(needle) > -1)
      })
    },

    setCurrency (val) {
      this.$emit('update:modelValue', val)
    }
  }
})
</script>
